//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2010-2010 - DIGITEO -
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function continueSimulation=REP_FREQ_pre_simulate(scs_m, needcompile)
    scs=[]

    // On recopie le scs_m
    scs=scs_m;
    // Retrieve all objects
    objs = scs_m.objs;

    nombre_blocs=0;    //Nombre de blocs dans le diagramme
    nombre_liens=0;    //Nombre de lien dans le diagramme
    nombre_rep_freq=0; //Nombre de blocs REP_FREQ dans le diagramme
    nombre_grandeur_phy=0;  //Nombre de blocs IN_Bode dans le diagramme
    num_grandeur_phy=[];    //Numéro des blocs grandeur physique dans le diagramme
    input_signals=[];   //vecteur des grandeurs d'entrée
    output_signals=[];   // vecteur des grandeurs de sortie
    type_diag=[];        // vecteur des types de diagrammes à tracer
    //    nombre_out_bode=0;  //Nombre de blocs OUT_Bode dans le diagramme
    //    num_out_bode=[];    //Numéro des blocs OUT_bode dans le diagramme
    w_min=[];
    w_max=[];
    num_w=[];            // Nombre de fréquences à tracer
    omega=[]             //vecteur des pulsations à tracer dans la réponse fréquentielle
    marges=[];    //marges à ne pas tracer

    //Récupère le nombre de blocs dans le modèle
    for i=1:size(objs)
        if typeof(objs(i))=='Block' then
            nombre_blocs=nombre_blocs+1;
        end
    end
    nombre_liens=size(objs)-nombre_blocs;  //calcul du nombre de liens

    // Récupère les blocs REP_freq et les paramètres associés
    // Recherche des blocs Retard et stockage des parametres associés
    for i=1:nombre_blocs
        if objs(i).gui=="REP_FREQ" then nombre_rep_freq=nombre_rep_freq+1;
            num_rep_freq(nombre_rep_freq)=i;
            input_signals(nombre_rep_freq)=objs(i).model.opar(1);
            output_signals(nombre_rep_freq)=objs(i).model.opar(2);
            type_diag(nombre_rep_freq)=objs(i).model.ipar;
            w_min(nombre_rep_freq)=objs(i).model.rpar(1);
            w_max(nombre_rep_freq)=objs(i).model.rpar(2);
            num_w(nombre_rep_freq)=objs(i).model.rpar(3);
            //            if exists("objs(i).model.rpar(3)") then
            //                if ~isempty(objs(i).model.rpar(3)) then
            //                    num_w=objs(i).model.rpar(3);
            //                end
            //            end
            marges(nombre_rep_freq)=objs(i).model.rpar(4);
        end

        //        if (typeof(curObj)=='Block'  & curObj.gui=="TIME_DELAY") then
        //            presence_delay=%t;
        //            delay_parameter=delay_parameter+curObj.model.rpar(1);
        //            //delay_parameter($+1)=curObj.model.rpar(1);
        //            //num_delay($+1)=i;
        //            //effacement du bloc TIME_DELAY et remplacement par un gain unitaire pour simplifier
        //            pin=curObj.graphics.pin;
        //            pout=curObj.graphics.pout;
        //            gain=GAINBLK_f('define')
        //            gain.graphics.pin = pin;
        //            gain.graphics.pout = pout;
        //            scs.objs(j)=gain;
        //        end       

    end

    // s'il y a déja des blocs IN_f et OUT_f, on demande à l'utilisateur de les retirer
    probleme_in_f=%f
    for i=1:nombre_blocs
        if objs(i).gui=="IN_f" | objs(i).gui=="OUT_f" then probleme_in_f=%t;
        end
    end
    if probleme_in_f then disp('Le tracé des réponses fréquentielles est incompatible avec la présence de blocs IN_f et OUT_f')
    end




    //-------------------------- Traitement à proprement parler
    // Pour chacun des bloc REP_FREQ trouvés dans le diagramme
    for i=1:nombre_rep_freq   //i est le bloc rep_freq que l'on traite
        presence_delay=%f; //flag indiquant si le schéma contient au moins un bloc TIME_DELAY
        delay_parameters=[]; //valeur des TIME_DELAY 
        num_delay=[]; //stockage des numéros de blocs TIME_DELAY
        BO_delay=[]; //flag indiquant si le bloc est dans la BO ou dans une BF        
        erreur1=%f;

        //modification du schema-bloc
        [scs,presence_delay,param_delays]=create_new_block_diag(scs_m,input_signals(i),output_signals(i))

        num_delay=param_delays.num_delay;
        delay_parameters=param_delays.delay_parameters;
        BO_delay=param_delays.BO_delay;

        //evaluation du contexte
        context=scs.props.context;
        [%scicos_context, ierr] = script2var(context,struct())
        %cpr=list();
        //   if exists('needcompile') then
        [scs, %cpr, needcompile, ok] = do_eval(scs, %cpr,%scicos_context);


        // On linearise le modele
        try
            sys=lincos(scs);
            tf=ss2tf(sys);

            if presence_delay then
                //modification du gain remplaçant le bloc TIME_DELAY pour tester si le bloc est dans une boucle ou pas
                for l=num_delay
                    scs2=scs;
                    //                scs2.objs(l).model.rpar=10;
                    //                scs2.objs(l).graphics.exprs=["10";"1"];
                    gain=GAINBLK_f('define')
                    gain.graphics.pin = scs2.objs(l).graphics.pin;
                    gain.graphics.pout = scs2.objs(l).graphics.pout;
                    gain.model.rpar=10;
                    gain.graphics.exprs="10";
                    scs2.objs(l)=gain;
                    sys2=lincos(scs2);
                    tf2=ss2tf(sys2);
                    gain.model.rpar=100;
                    gain.graphics.exprs="100";
                    scs2.objs(l)=gain;
                    sys3=lincos(scs2);
                    tf3=ss2tf(sys3);

                    test_bo=tf3/tf2;
                    s=poly(0,"s");
                    if test_bo==10 then
                        disp("Bloc dans une BO") //on laisse le bloc avec un gain de 1, on multipliera la BO par exp(-tr*s) ensuite
                        BO_delay(find(num_delay==l))=%t;
                    else
                        disp("Bloc dans une BF - Approximation Pade ordre 3") //on modifie le bloc en le remplaçant par une approximation de Pade à l'ordre 3
                        BO_delay(find(num_delay==l))=%f;
                    end
                end

                //nouvelle boucle pour mettre à jour le schéma bloc de manière à prendre en compte les approximations de Pade ou non
                total_delay_BO=0;
                for l=1:size(num_delay,2)
                    num_obj=num_delay(l);
                    tr=delay_parameters(l);
                    if BO_delay(l)==%f then
                        s=poly(0,"s");
                        //                    num=1-tr*s/2+(tr*s)^2/8-(tr*s)^3/48;
                        //                    den=1+tr*s/2+(tr*s)^2/8+(tr*s)^3/48;
                        num=1-tr*s/2;
                        den=1+tr*s/2;
                        scs.objs(num_obj).graphics.exprs=[sci2exp(num),sci2exp(den)];
                        H=cont_frm(num,den);
                        [A,B,C,D]=H(2:5);
                        [ns1,ns1]=size(A);
                        rpar=[matrix(A,ns1*ns1,1);
                        matrix(B,ns1,1);
                        matrix(C,ns1,1);
                        D]
                        scs.objs(num_obj).model.rpar=rpar;
                    else
                        total_delay_BO=total_delay_BO+tr;
                    end    
                end
                sys=lincos(scs)
                tf=ss2tf(sys)

            end
            // On indique la fonction de transfert dans la console :
            disp(["Scilab a réussi à extraire une fonction de transfert du schéma bloc : ("+sci2exp(tf(2))+")/("+sci2exp(tf(3))+")"])
        catch
            message(["Scilab n a pas réussi à linéariser le système" "Vérifier que tous les blocs sont linéaires et causaux"])
            erreur1=%t
        end

        //        if ~erreur1
        //
        //            // On indique la fonction de transfert dans la console :
        //            disp(["Scilab a réussi à extraire une fonction de transfert du schéma bloc : ("+sci2exp(tf(2))+")/("+sci2exp(tf(3))+")"])
        //            
        
        // ------ Tracé en fonction du type choisi ----------
        // On construit le vecteur des omega
        if num_w(i)>0 then
            omega=logspace(log10(w_min(i)/(2*%pi)),log10(w_max(i)/(2*%pi)),num_w(i));
        end

        // On choisit le diagramme à tracer
        h=figure();
        set(h,"background",8)
        name_diag=["Diagrammes de Bode","Diagramme de Black","Diagramme de Nyquist"];
        h.figure_name=name_diag(type_diag(i))+" : Entrée "+input_signals(i)+" Sortie "+output_signals(i);
        drawlater();


        select type_diag(i)
        case 1
            if num_w(i)>0 then
                try
                    h1=sys;
                    if presence_delay==%t then
                        h1=iodelay(tf,total_delay_BO);
                        bode(h1,w_min(i)/(2*%pi),w_max(i)/(2*%pi));
                    else

                        bode(h1,omega);
                    end

                catch
                    disp(["Scilab a réussi à extraire une fonction de transfert du schéma bloc mais n''est pas parvenu à tracer la réponse fréquentielle.","La fonction de transfert obtenue est : ("+sci2exp(tf(2))+")/("+sci2exp(tf(3))+")"])

                end
            else
                try
                    h1=sys;
                    if presence_delay==%t then
                        h1=iodelay(tf,delay_parameter);
                    end
                    bode(h1,w_min(i)/(2*%pi),w_max(i)/(2*%pi));
                    //bode(sys,w_min/(2*%pi),w_max/(2*%pi));
                catch
                    disp(["Scilab a réussi à extraire une fonction de transfert du schéma bloc mais n''est pas parvenu à tracer la réponse fréquentielle.","La fonction de transfert obtenue est : ("+sci2exp(tf(2))+")/("+sci2exp(tf(3))+")"])

                end
            end
            
            bode_Hz2rad_2(h,marges(i));

            if marges(i)==1 then
                freq_analysis(sys,'bode');
            end

        case 2

            if num_w(i)>0 then
                try
                    black(sys,omega);
                    if(h.children.data_bounds(1)>-180) 
                        h.children.data_bounds(1)=-180;
                    end
                    nicholschart(colors=color('light gray')*[1 1])
                catch
                    disp(["Scilab a réussi à extraire une fonction de transfert du schéma bloc mais n''est pas parvenu à tracer la réponse fréquentielle.","La fonction de transfert obtenue est : ("+sci2exp(tf(2))+")/("+sci2exp(tf(3))+")"])

                end
            else
                try
                    black(sys,w_min(i)/(2*%pi),w_max(i)/(2*%pi));
                    if(h.children.data_bounds(1)>-180) 
                        h.children.data_bounds(1)=-180;
                    end

                    nicholschart(colors=color('light gray')*[1 1])
                catch
                    disp(["Scilab a réussi à extraire une fonction de transfert du schéma bloc mais n''est pas parvenu à tracer la réponse fréquentielle.","La fonction de transfert obtenue est : ("+sci2exp(tf(2))+")/("+sci2exp(tf(3))+")"])
                end
            end

            if marges(i)==1 then
                freq_analysis(sys,'black');
            end

        case 3
            if num_w(i)>0 then
                try
                    nyquist(sys,w_min(i)/(2*%pi),w_max(i)/(2*%pi),1/num_w(i));
                    //nyquist(sys,w_min(i)/(2*%pi),w_max(i)/(2*%pi));
                catch
                    disp(["Scilab a réussi à extraire une fonction de transfert du schéma bloc mais n''est pas parvenu à tracer la réponse fréquentielle.","La fonction de transfert obtenue est : ("+sci2exp(tf(2))+")/("+sci2exp(tf(3))+")"])
                end
            else
                try
                    nyquist(sys,w_min(i)/(2*%pi),w_max(i)/(2*%pi));
                catch
                    disp(["Scilab a réussi à extraire une fonction de transfert du schéma bloc mais n''est pas parvenu à tracer la réponse fréquentielle.","La fonction de transfert obtenue est : ("+sci2exp(tf(2))+")/("+sci2exp(tf(3))+")"])
                end
            end

        end

        set(h,"background",8)

        //end
        drawnow();
    end

    // Force Simulation to start after pre_simulation process.
    continueSimulation = %t
endfunction



function [scs,presence_delay,param_delays]=create_new_block_diag(scs_m,input_signal,output_signal)
    scs=scs_m; // On repart sur un diagramme propre
    num_in=[] // le numéro du bloc d'entrée dans le diagramme original
    num_out=[] // Le numéro du bloc de sortie dans le diagramme original
    //Parametres pour la gestion des blocs retard
    param_delays.delay_parameters=[]; //valeur des TIME_DELAY 
    param_delays.num_delay=[]; //stockage des numéros de blocs TIME_DELAY
    param_delays.BO_delay=[]; //flag indiquant si le bloc est dans la BO ou dans une BF   


    //---------- Traitement des blocs retard TIME_DELAYS-----------
    // On cherche et on remplace les blocs TIME_DELAYS
    for j = 1:size(scs.objs)
        curObj= scs.objs(j);
        if (typeof(curObj)=='Block'  & curObj.gui=="TIME_DELAY") then
            presence_delay=%t;
            param_delays.num_delay($+1)=j;
            param_delays.delay_parameters($+1)=curObj.model.rpar(1);
            param_delays.BO_delay($+1)=%f;
            //effacement du bloc TIME_DELAY et remplacement par un fct de transfert égale à un gain pur au début
            //                gain=GAINBLK_f('define')
            //                gain.graphics.pin = curObj.graphics.pin;
            //                gain.graphics.pout = curObj.graphics.pout;
            //                scs.objs(j)=gain;
            approx=CLR('define')
            approx.graphics.pin = curObj.graphics.pin;
            approx.graphics.pout = curObj.graphics.pout;
            approx.graphics.exprs=["1";"1"];
            approx.model.rpar=1;
            scs.objs(j)=approx;
        end
    end
    //---------- Traitement des blocs retard TIME_DELAYS-----------      

    //---------- Traitement de l'entrée -----------
    // On récupère le bloc grandeur physique d'entrée

    for j = 1:size(scs.objs)
        curObj= scs.objs(j);
        if (typeof(curObj) == "Block" & curObj.gui == "GRANDEUR_PHYSIQUE")
            if curObj.graphics.exprs==input_signal then
                num_in=j;
            end
        end
    end

    //On recalcule le nombre de blocs
    nombre_blocs=0
    for iii=1:size(scs.objs)
        if typeof(scs.objs(iii))=='Block' then
            nombre_blocs=nombre_blocs+1;
        end
    end
    nombre_liens=size(scs.objs)-nombre_blocs;  //calcul du nombre de liens


    // On décale tous les liens d'un cran
    for k=1:nombre_liens
        scs.objs(nombre_blocs+nombre_liens+2-k)=scs.objs(nombre_blocs+nombre_liens+1-k);
    end

    //On décale tout les pin et pout des blocs pour rester en concordances avec les liens
    for l=1:nombre_blocs
        if ~isempty(scs.objs(l).graphics.pin) then scs.objs(l).graphics.pin=scs.objs(l).graphics.pin+1
        end
        if ~isempty(scs.objs(l).graphics.pout) then scs.objs(l).graphics.pout=scs.objs(l).graphics.pout+1
        end
        if ~isempty(scs.objs(l).graphics.pein) then scs.objs(l).graphics.pein=scs.objs(l).graphics.pein+1
        end
        if ~isempty(scs.objs(l).graphics.peout) then scs.objs(l).graphics.peout=scs.objs(l).graphics.peout+1
        end
    end

    // On crée un bloc grandeur physique d'entrée en tant qu'objet nombre blocs+1 avec le numéro d'entrée correspondant
    nombre_blocs=nombre_blocs+1;   // Le nombre de bloc est incrémenté
    scs.objs(nombre_blocs)=IN_f('define') // Crée un nouveau bloc IN_f
    scs.objs(nombre_blocs).graphics.exprs=scs_m.objs(num_in).graphics.exprs  // On récupère le numéro de l'entrée
    // On remplace le blocs IN_Bode par un GOTO (ce qui vient avant le bloc grandeur physique est alors inutilisé)
    scs.objs(num_in)=GOTO('define');
    // On relie les nouveaux blocs aux liens existants et au nouveau lien
    // pour le bloc GOTO (remplace bloc grandeur physique d'entrée)
    scs.objs(num_in).graphics.orig=scs_m.objs(num_in).graphics.orig;
    old_num_pin= scs_m.objs(num_in).graphics.pin(1);
    scs.objs(num_in).graphics.pin= old_num_pin+1; //on garde le numero du lien d'entrée de l'ancien bloc + 1 (car ajout d'un bloc)
    scs.objs(num_in).graphics.sz= [40,40];
    // pour le bloc IN_f
    scs.objs(nombre_blocs).graphics.orig=[scs_m.objs(num_in).graphics.orig(1)+30,scs_m.objs(num_in).graphics.orig(2)-30];
    scs.objs(nombre_blocs).graphics.sz=[40,40];
    old_num_pout=scs_m.objs(num_in).graphics.pout(1);
    scs.objs(nombre_blocs).graphics.pout=old_num_pout+1;
    // On modifie le from-to du lien correspondant
    scs.objs(old_num_pout+1).from=[nombre_blocs 1 1];
    //---------- Traitement de l'entrée -----------

    //---------- Traitement de la sortie ----------
    // On récupère le bloc grandeur physique de sortie
    for j = 1:size(scs.objs)
        curObj= scs.objs(j);
        if (typeof(curObj) == "Block" & curObj.gui == "GRANDEUR_PHYSIQUE")
            if curObj.graphics.exprs==output_signal then
                num_out=j;
            end
        end
    end

    // On décale tout les liens d'un cran
    for k=1:nombre_liens
        scs.objs(nombre_blocs+nombre_liens+2-k)=scs.objs(nombre_blocs+nombre_liens+1-k);
    end

    //On décale tout les pin et pout des blocs pour rester en concordances avec les liens
    for l=1:nombre_blocs
        if ~isempty(scs.objs(l).graphics.pin) then scs.objs(l).graphics.pin=scs.objs(l).graphics.pin+1
        end
        if ~isempty(scs.objs(l).graphics.pout) then scs.objs(l).graphics.pout=scs.objs(l).graphics.pout+1
        end
        if ~isempty(scs.objs(l).graphics.pein) then scs.objs(l).graphics.pein=scs.objs(l).graphics.pein+1
        end
        if ~isempty(scs.objs(l).graphics.peout) then scs.objs(l).graphics.peout=scs.objs(l).graphics.peout+1
        end
    end

    // On crée un bloc OUT_f en tant qu'objet nombre blocs+1 avec le numéro de sortie correspondant
    nombre_blocs=nombre_blocs+1;   // Le nombre de bloc est incrémenté
    scs.objs(nombre_blocs)=OUT_f('define') // Crée un nouveau bloc out_f
    scs.objs(nombre_blocs).graphics.exprs=scs_m.objs(num_out).graphics.exprs  // On récupère le numéro de l'entrée

    // On remplace le blocs grandeur physique de sortie par un bloc CONST_m 
    scs.objs(num_out)=CONST_m('define');//

    // On relie les nouveaux blocs aux liens existants
    //Pour le bloc CONST_m
    scs.objs(num_out).graphics.orig=scs_m.objs(num_out).graphics.orig
    old_num_pout=scs_m.objs(num_out).graphics.pout(1);
    scs.objs(num_out).graphics.pout= old_num_pout+2;

    //Pour le bloc OUT_f
    scs.objs(nombre_blocs).graphics.orig=[scs_m.objs(num_out).graphics.orig(1)+10,scs_m.objs(num_out).graphics.orig(2)-30]
    scs.objs(nombre_blocs).graphics.sz=[40,40]
    old_num_pin=scs_m.objs(num_out).graphics.pin(1);
    scs.objs(nombre_blocs).graphics.pin= old_num_pin+2;
    //On modifie le from-to du lien correspondant
    scs.objs(old_num_pin+2).to=[nombre_blocs 1 1]
    //---------- Traitement de la sortie ----------

endfunction






