//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function [x,y,typ]=SQUARE_WAVE_f(job,arg1,arg2)
    x=[];y=[];typ=[];
    select job
     case 'plot' then
// deprecated
     case 'getinputs' then
// deprecater
     case 'getoutputs' then
// deprecated
     case 'getorigin' then
// deprecated
     case 'set' then
         x=arg1;
         graphics=arg1.graphics;
         exprs=graphics.exprs
         model=arg1.model;
         while %t do
            [ok,ampl,period,start_time,exprs]=scicos_getvalue(gettext('Set Square generator block parameters'),..
                                                        ['Amplitude';gettext('Period'); gettext('Start Time')], ..
                                                        list('vec',1,'vec',1,'vec',1), ..
                                                        exprs)
          mess=[];
          if ~ok then //cancel
              break;
          end
          
          if ok then
              //modification of the clock
//              model.rpar.objs(2).model.rpar.objs(2).graphics.exprs=[string(period);string(start_time)];
//              model.rpar.objs(2).model.rpar.objs(2).model.rpar=[period;start_time];
//              model.rpar.objs(2).model.rpar.objs(2).model.firing=start_time;
//              model.rpar.objs(2).model.firing= -1;
              model.rpar.objs(2).graphics.exprs=[string(period) ; string(start_time)];
              model.rpar.objs(2).model.ipar=1;
              model.rpar.objs(2).model.rpar = [10 ; 0];
              //modification of the GENSQR_f block
              model.rpar.objs(1).graphics.exprs = string(ampl);
              model.rpar.objs(1).model.dstate = ampl;
              
              graphics.exprs = exprs;
              x.model=model;
              x.graphics = graphics;
              break
          else
              message(mess);
          end
     end
     case 'define' then
      //definition of parameters set by user
      ampl = 1;
      period = 1;
      start_time=0;

      //definition of the block GENSQR_f
      entry=GENSQR_f('define');
      entry.graphics.exprs = string(ampl);
      entry.model.dstate = ampl;
      entry.graphics.pein = 4;
     
      //definition of the clock
      clockc=SampleCLK('define')
      clockc.graphics.exprs=[string(period) ; string(start_time)];
      clockc.model.rpar = [period ; start_time];
//      clockc.model.rpar.objs(2).graphics.exprs=[string(period);string(start_time)];
//      clockc.model.rpar.objs(2).model.rpar=[period;start_time];
//      clockc.model.rpar.objs(2).model.firing=start_time;
      clockc.graphics.peout=4;

      //definition of the output block
      output_port=OUT_f('define')
      output_port.graphics.exprs=["1"]
      output_port.graphics.pin=5;  
      
      //definition of the scicos_diagram
      diagram=scicos_diagram();
      diagram.objs(1)=entry;
      diagram.objs(2)=clockc;
      diagram.objs(3)=output_port;
      diagram.objs(4)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[5, -1], from=[1, 1,1], to=[2, 1,0])
      diagram.objs(5)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1, 1], from=[1, 1,0], to=[3, 1,1])
      

      model = scicos_model();
      model.sim='csuper'
      model.in=[]
      model.in2=[]
      model.intyp=[]
      model.out=-1;
      model.out2=-2;
      model.outtyp=-1;
      model.blocktype='h'
      model.dep_ut=[%f %t]
      //model.ipar=1;
      model.rpar=diagram
      exprs=[ string(ampl) ; string(period) ; string(start_time)];
      x = standard_define([2 2], model,exprs, [])
      x.gui='SQUARE_WAVE_f'
      x.graphics.exprs=exprs;
    end
endfunction

